; epyxdump.asm
; dumps Epyx Fastload cartridge
; Version 1.0
; machine language part


* = $0801

.INCLUDE SYSTEM.ASM			; KERNAL functions

		.byte $26,$08,$0a,$00,$99,$22
		.text "EPYXDUMP - DUMP EPYX FASTLOAD"
		.byte $22,$00
		.byte $30,$08,$1e,$00,$9e,$32,$30,$39,$39,$00
;		.byte <_end,>_end,$28,$00,$00
		.byte $00,$00,$00
		
		SEI
		LDX  #$40
_enableFL	INC  $de00
		DEX
		BNE  _enableFL
		LDY  #$20
_copyL1		LDA  $8000,X
		STA  $4000,X
		INX
		BNE  _copyL1
		INC  _copyL1+2
		INC  _copyL1+5
		DEY
		BNE  _copyL1
		CLI

		JSR  _promptSave
		JSR  _waitFire
		JSR  _saveCart
		JSR  _promptDone
_the_end	JMP  _the_end
	

_saveCart	JSR  CLRCHN
		JSR  CLALL
		LDA  #$01
		LDX  $ba		; FA - Use current Device Number
		TAY
		JSR  SETLFS		; SETLFS 1,8,1

		LDA  _namelen
		LDX  #<_filename
		LDY  #>_filename
		JSR  SETNAM
		LDX  #$00		; source memory $4000
		LDY  #$40
		STX  $fb
		STY  $fc
		LDA  #$fb
		LDX  #$00		; end of source memory $6000
		LDY  #$60
		JSR  SAVE
		LDA  #$01
		JSR  CLOSE
		RTS

_namelen	.byte $6
_filename	.text "EPYXFL"


_promptSave     LDY  #$00
_promptSaveL1	LDA  _save_text,Y
		BEQ  _promptSaveJ1
		JSR  CHROUT
		INY
		BNE  _promptSaveL1
_promptSaveJ1	RTS

_promptDone	LDY  #$00
_promptDoneL1	LDA  _done_text,Y
		BEQ  _promptDoneJ1
		JSR  CHROUT
		INY
		BNE  _promptDoneL1
_promptDoneJ1	RTS


_save_text	.byte $0d,$0d
		.text "PLEASE INSERT SAVE DISK"
		.byte $0d
		.text "AND PRESS <SPACE> KEY!"
		.byte 0

_done_text	.byte $0d,$0d
		.text "DONE!"
		.byte 0


_waitFire	LDA  $dc00		; wait for fire button up
		AND  $dc01
		AND  #$10
		BEQ  _waitFire
_waitFireL1	LDA  $dc00		; wait for fire button
		AND  $dc01
		AND  #$10
		BNE  _waitFireL1
		RTS

_end		.byte $00,$00,$00
